'use strict';

var defaultColors = {
  keyColor: 'dimgray',
  numberColor: 'lightskyblue',
  stringColor: 'lightcoral',
  trueColor: 'lightseagreen',
  falseColor: '#f66578',
  nullColor: 'cornflowerblue'
};

function index (json, colorOptions) {
  if ( colorOptions === void 0 ) colorOptions = {};

  if (!json) { return; }
  if (typeof json !== 'string') {
    json = JSON.stringify(json, null, 2);
  }
  var colors = Object.assign({}, defaultColors, colorOptions);
  json = json.replace(/&/g, '&').replace(/</g, '<').replace(/>/g, '>');
  return json.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+]?\d+)?)/g, function (match) {
    var color = colors.numberColor;
    if (/^"/.test(match)) {
      color = /:$/.test(match) ? colors.keyColor : colors.stringColor;
    } else {
      color = /true/.test(match) ? colors.trueColor : /false/.test(match) ? colors.falseColor : /null/.test(match) ? colors.nullColor : color;
    }
    return ("<span style=\"color: " + color + "\">" + match + "</span>");
  });
}

module.exports = index;
